#include"ndpd.h"

#define GET8(val, cp)	((val) = *(cp)++)

#define GET16(val, cp)	\
	{ \
		(val) = *(cp)++ << 8; \
		(val) |= *(cp)++; \
	}

#define GET32(val, cp)	\
	{ \
		(val) = *(cp)++ << 24; \
		(val) |= *(cp)++ << 16; \
		(val) |= *(cp)++ << 8; \
		(val) |= *(cp)++; \
	}

#define GETADDR(val, cp)	\
	{ \
		bcopy((cp), &(val), 16); \
		(cp) += 16; \
	}

char myopen_bpf();
void myclose_bpf();
void myrecv_bpf();
void manage_pkt(struct ip6_hdr *);
void interp(u_char,char *);

static char p_buf[NPR6BUF][INET6_ADDRSTRLEN];
static int p_pos = 0;
#define PR_NXTBUF	p_buf[p_pos = (p_pos + 1) % NPR6BUF]
#define PR_CURBUF	p_buf[p_pos]

const char *
inet6pr(addr)
	register struct in6_addr *addr;
{
	return inet_ntop(AF_INET6, addr, PR_NXTBUF, INET6_ADDRSTRLEN);
}

int mysocket;

void main()
{
    int nfds, cc;
    fd_set rfds;
    struct timeval tv;
    
   if ( myopen_bpf() ==0)
   {
	puts("problem during the bpf stuff");
	exit(3);
   }
    puts("start sniffing");
    while(1)
    {
	FD_ZERO(&rfds);
	FD_SET(mysocket, &rfds);
	nfds = mysocket > nfds ? mysocket : nfds;
	
	cc = select(nfds + 1, &rfds, NULL, NULL, 0);
	if ((cc < 0) ||(cc == 0))
	{
    	    puts("select");
	    continue;
	}

	if (FD_ISSET(mysocket, &rfds))
	    myrecv_bpf();    
	
    }

}
/* ether proto 0x86dd and ether[20]==0x3c and ether[54]==0x3b 
   and (ether[56]==0xc6 or ether[56]==0x09)*/
char bbuf[1000];
struct bpf_insn bi[] = 
{
    BPF_STMT(BPF_LD  +  BPF_B    +  BPF_ABS,  13),
    BPF_JUMP(BPF_JMP +  BPF_JEQ  +  BPF_K,    0xdd,  0,  7),
    BPF_STMT(BPF_LD  +  BPF_B    +  BPF_ABS,  12),
    BPF_JUMP(BPF_JMP +  BPF_JEQ  +  BPF_K,    0x86,  0,  5),
    BPF_STMT(BPF_LD  +  BPF_B    +  BPF_ABS,  20),
    BPF_JUMP(BPF_JMP +  BPF_JEQ  +  BPF_K,    0x3c,  0,  3),
    BPF_STMT(BPF_LD  +  BPF_B    +  BPF_ABS,  56),
    BPF_JUMP(BPF_JMP +  BPF_JEQ  +  BPF_K,    0xc6,  2,  0),
    BPF_STMT(BPF_LD  +  BPF_B    +  BPF_ABS,  56),
    BPF_JUMP(BPF_JMP +  BPF_JEQ  +  BPF_K,    0x09,  0,  1),
    BPF_STMT(BPF_RET +  BPF_K, 1000),
    BPF_STMT(BPF_RET +  BPF_K, 0),
};

struct bpf_program bp = { 12, bi };

/*
open the socket used to filter packet

called by : main
call :
*/
char myopen_bpf()
{
    struct if_laddrreq ifr6;
    struct ifreq ifr;
    struct sockaddr_in6 *sin;
    char dname[12];
    int d, unit = 0;
    u_int val;
    u_char br;
    char i;
    char interface[10];
    FILE *conf;

    conf = fopen("./snif.conf","r");
    if (conf == NULL)
    {
	puts("no snif.conf file");
	return 0;
    }
    
    br = fread(interface,10,1,conf);
    fclose(conf);
    
    i =0;
    while (i<10)
	if(! isalnum(interface[i++]))
	{
	    interface[i-1] = 0x0;
	    break;
	}
	    
    printf("interface = %s\n",interface);
retry:
    /* try to open */
	(void) snprintf(dname, sizeof(dname) - 1, "/dev/bpf%d", unit++);
	if ((mysocket = open(dname, O_RDONLY)) < 0) 
	{
		puts("open (BPF)");
		return 0;
	}
    /* initialize the buffer length */
	val = 250;
	if (ioctl(mysocket, BIOCSBLEN, &val) < 0)
	{
		puts("ioctl (BIOCSBLEN)");
		return 0;
	}
    /* start the sniffing NOW ! */
	val = 1;
	if (ioctl(mysocket, BIOCIMMEDIATE, &val) < 0)
	{
		puts("ioctl (BIOCIMMEDIATE)");
		return 0;
	}
    /* attach the bpf to physical interface */
	bzero(&ifr, sizeof(ifr));
	strncpy(ifr.ifr_name, interface, IFNAMSIZ);
	if ((ioctl(mysocket, BIOCSETIF, &ifr) < 0) )
	{
		puts("ioctl (BIOCSETIF)");
		return 0;
	}
    /* program the bpf */
	if (ioctl(mysocket, BIOCSETF, &bp) < 0)
	{
		puts("ioctl (BIOCSETF)");
		return 0;
	}

	printf("open BPF on %s linked on %s\n", 
			    dname,interface);
	return 1;
}


/*
close the socket

called by : main
call :
*/
void myclose_bpf()
{
    if (mysocket < 0)
		return;
	(void) ioctl(mysocket, BIOCFLUSH, NULL);
	(void) close(mysocket);
	mysocket = -1;
}


/*
receive and manage a bpf packet

called by : main
call : manage_pkt
*/

void myrecv_bpf()
{
	struct bpf_hdr *hp;
	struct ip6_hdr *ip;
	u_int *afp;
	char *p;
	int cc;
	char bbuf[250];

    /* do some check on the packet */

	cc = read(mysocket, bbuf, sizeof(bbuf));

	if (cc < 0) 
	{
		puts("read (BPF)");
		return;
	}
	if (cc < sizeof(*hp)) 
	{
		printf("recv_bpf: very short (%d) read", cc);
		return;
	}
	p = bbuf;
	for (;;) 
	{
	    hp = (struct bpf_hdr *)p;
	    p+=32;	
	    ip = (struct ip6_hdr *)p;
	    
	    if ((ip->ip6_flow & IPV6_FLOWINFO_VERSION) != IPV6_VERSION)
		return;
	    
	    manage_pkt(ip);
	    
next:
	    p += BPF_WORDALIGN(hp->bh_hdrlen + hp->bh_caplen);
	    if (p >= bbuf + cc)
		break;
	}
}

/*
search if the packet is a home registration or a simple binding update
dump some log on screen

called by : recv_bpf
call :
*/
void manage_pkt(ip)
struct ip6_hdr * ip;
{
    char * ptr;
    u_char flags;
    u_char plen;
    u_short seq;
	u_char size;
    u_int life;
    struct in6_addr * careof = &ip->ip6_src;
    struct in6_addr home ;
    struct in6_addr old ;
    struct in6_addr tmp;
    char strflags [4];

    puts("\n============================================================");

    ptr = (char *)ip;
    ptr += sizeof(struct ip6_hdr);
	ptr +=2;
	if( *ptr == 0x09)
		goto hmip;
			
	ptr +=1;
	size = (u_char)(*ptr);
    ptr +=1;

   	GET8(flags, ptr);
	GET8(plen, ptr);
	GET16(seq, ptr);
	GET32(life, ptr);

	if(size == 0x1c)
	{
		ptr+=4;
		GETADDR(tmp, ptr);
		if (!IN6_ARE_ADDR_EQUAL(&tmp, careof))
			printf("real careof is %s\n", inet6pr(&tmp));
		
		ptr+=4;
	}

	ptr+=4;

	GETADDR(home,ptr);

	if(flags & OPT6_BNDU_HR)
	{
    	    printf("home registration\n\tfor "
			 "(home) \t%s\n\tfrom \t\t%s\n",
			 inet6pr(&home), inet6pr(&ip->ip6_src));
	}
	else
	{
    	    printf("binding update\n\tfor "
			 "(home) \t%s\n\tfrom \t\t%s\n",
			 inet6pr(&home), inet6pr(&ip->ip6_src));
	}
	printf("\tto \t\t%s\n",inet6pr(&ip->ip6_dst));
    interp(flags,strflags);
	printf("\tsize=%d flags=%s(%x) plen=%d seq=%u life=%lx\n",
			 size,strflags,flags,  plen, seq, life);
	return;
hmip:
	ptr+=2;

   	GET8(flags, ptr);
	GET8(plen, ptr);
	GET16(seq, ptr);
	GET32(life, ptr);
	
	ptr +=4;
	GETADDR(old,ptr);
	ptr +=8;
	GETADDR(home,ptr);

    printf("hmip registration\n\tfor "
		 "(home) \t%s\n\tfrom \t\t%s\n",
		 inet6pr(&home), inet6pr(&ip->ip6_src));
	printf("\tto \t\t%s\n",inet6pr(&ip->ip6_dst));
	printf("\told \t\t%s\n",inet6pr(&old));
	printf("\tsize=%d flags=%x plen=%d seq=%u life=%lx\n",
			 size,flags,  plen, seq, life);
	
}
/*
print the flag as human way

called by : manage_pkt
call :
*/
void interp(flags,strflags)
u_char flags;	/* flag to print */
char *strflags;	/* human readable flags */
{
    switch (flags)
    {
	case(0xe0):  strcpy(strflags,"AHC");return;
	case(0xc0):  strcpy(strflags,"AH");return ;
	case(0xa0):  strcpy(strflags,"AC");return ;
	case(0x20):  strcpy(strflags,"C");return ;
	case(0x40):  strcpy(strflags,"H");return ;
	case(0x60):  strcpy(strflags,"HC");return ;
	default:     strcpy(strflags,"__");return ;
    }
}
