/* Support for minor movements (between remote sites) */

#ifdef MOBILE

#include "ndpd.h"
#include "mobility.h"

#ifdef UHMMA
#include "../ndpd-uhmma/uhmma.h"
#endif

/* alerted by care-of prefix zap/change */

void
minor_move(ifp, pp)
	struct interface *ifp;
	struct prefix *pp;
{
	register struct corr *cop;
	register struct homeaddr *hap;
	struct prefix *newpp = NULL;

	cop = correspondents.tqh_first;

	/* find the associated home address */

	FORALLHA(hap)
		if ((pp != NULL) && (hap->capp == pp))
			break;
		else if ((pp == NULL) && (hap->capp != NULL) &&
			 hap->capp->ifp == ifp) {
			pp = hap->capp;
			break;
		}
	if ((pp == NULL) || (hap == NULL))
		goto found;

	/* find the new care-of address */

	FORALLPP(newpp, ifp)
		if ((newpp->mflags & MOB_ISHA) == 0)
			break;
	if (newpp == pp)
		goto found;
	if (newpp)
		goto found;
	if (verbose)
		logtrace("minor_move: no home prefix");
	return;

    found:

	/* Trivial cases where nothing will be done */

	if (hap == NULL) {
		if (verbose)
			logtrace("minor_move: no home address");
		return;
	} else if (cop == NULL) {
		if (verbose)
			logtrace("minor_move: no correspondent");
		return;
	} else if ((pp == NULL) || ((pp->mflags & MOB_ISCA) == 0)) {
		if (verbose)
			logtrace("minor_move: unused interface");
		return;
	} else if (newpp == pp) {
		if (verbose)
			logtrace("minor_move: no change");
		return;
	}

	/* change care-of prefix */

	pp->mflags &= ~MOB_ISCA;
	newpp->mflags |= MOB_ISCA;
	FORALLHA(hap)
		if (hap->capp == pp)
			hap->capp = newpp;
#ifdef UHMMA
/* mode 2 just send reg pkt to the ma
   mode 1 send reg pkt to the local ma n send bu
 */
    /* check for mobility mode swap */
    if(global.swap_in_progress ==1)
	return;
    if(global.mobility_mode < global.MA_mode)
	if(global.mobility_mode < global.mobility_mode_init)
	{
	    global.need_to_swap =(global.mobility_mode_init > global.MA_mode ?
				    global.MA_mode : global.mobility_mode_init );
	    swap_mode(&newpp->addr);
	    return;
	}
    /* movement management */
    if((global.mobility_mode == UHMMA_MODE2)||
       (global.mobility_mode == UHMMA_MODE1))
    {
    	send_uhmma_minor_reg(&newpp->addr);
	if (global.mobility_mode == UHMMA_MODE2) 
	    return;
    }
#endif

	/* do it! */

	FORALLCOR(cop)
		mobile_move(cop, &newpp->addr);
}

#endif
