#include <stdio.h>
#include "../ndpd-host/ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "uhmma.h"

#define SET8(val, cp)	(*(cp)++ = val)

#define SET16(val, cp)	\
	{ \
		*(cp)++ = (val) >> 8; \
		*(cp)++ = (val); \
	}

#define SET32(val, cp)	\
	{ \
		*(cp)++ = (val) >> 24; \
		*(cp)++ = (val) >> 16; \
		*(cp)++ = (val) >> 8; \
		*(cp)++ = (val); \
	}

#define SETADDR(val, cp)	\
	{ \
		bcopy(&(val), (cp), 16); \
		(cp) += 16; \
	}

void uhmma_reg();


int main ()
{
    char choice;

begin:
    puts("1- UHMMA reg\n2- bu\n3- back\n4- req\n");
    scanf("%c",&choice);

    switch(choice)
    {
	case '1' :
	    uhmma_reg();
	    goto begin;
	case '2' :
	case '3' :
	case '4' :
	    goto begin;
    }

    return;
}


void uhmma_reg()
{
    struct in6_addr src6,dst6,MA_old,haddr,home;
    char sstring[30];
    char * ptr = sstring;
    int life = 0x200;
    u_short seq=1;
    char mode;
    
	register u_char *cp;
	int byte_length = 72;
	int byte_8_length = (byte_length -8) / 8;
	char bubuf[byte_length];
    
    puts("source v6");
    scanf("%s",sstring);
    inet_pton(AF_INET6, ptr, &src6);
    puts("dest v6");
    scanf("%s",sstring);
    inet_pton(AF_INET6, ptr, &dst6);
    puts("mode");
    scanf("%c",&mode);
    CLR_ADDR6(MA_old);
    
    strcat (ptr,"3ffe:306:1301:2::165");
    inet_pton(AF_INET6, ptr, &haddr);

    {
    int i,j;
    CLR_ADDR6(home);
    j = 8;
    for(i=0 ;i<j ;i++ )
        home.s6_addr[i] = haddr.s6_addr[i];
    for(i=j ;i<16 ;i++ )
        home.s6_addr[i] = src6.s6_addr[i];
    
    }

	cp = (u_char *)bubuf;

	SET8(IP6_NHDR_NONH, cp);
	SET8(byte_8_length, cp);
	/* DO BU  */
	SET8(OPT6_BINDING_UPD, cp);
	SET8(UHMMA_BU_DO_LENGTH, cp);
	SET8(mode-49, cp);	
	SET8(0, cp);        
	SET16(seq, cp);
	SET32(life, cp);
	/* sub option MA */
	SET8(SUB_OPT6_MA, cp);
	SET8(UHMMA_MA_SUBO_LENGTH, cp);
	SET8(OPT6_PAD_0, cp);
	SET8(OPT6_PAD_0, cp);
	SETADDR(MA_old, cp);
	/* sub option HA */
	SET8(SUB_OPT6_HA, cp);
	SET8(UHMMA_HA_SUBO_LENGTH, cp);
	SET8(OPT6_PAD_0, cp);
	SET8(OPT6_PAD_0, cp);
	SETADDR(haddr, cp);
	
	SET8(OPT6_PAD_0, cp);
	SET8(OPT6_PAD_0, cp);

	/* DO H@ */
	SET8(OPT6_HOME_ADDR, cp);
	SET8(16, cp);       /* length */
	SETADDR(home, cp);

	/* send */
	if(send_kernel("send uhmma reg",bubuf,sizeof(bubuf),
			&src6,&dst6,0,0)==0)
	    puts("   error");
	else
	    puts("   ok");      
}



char send_kernel(location,buffer,size,src,dst,disable_home,disable_rth)
char * location;	/* string to print if problems occur */
char * buffer;		/* packet to send */
int    size;		/* size of the packet */
struct in6_addr * src;	/* source */
struct in6_addr * dst;	/* destination */
char   disable_home;	/* disable home address option */	
char   disable_rth;	/* disable routing header */
{
    	struct sockaddr_in6 sin;
	int d, cc;

	/* get a fresh socket */
	if ((d = socket(PF_INET6, SOCK_RAW, IPPROTO_DSTOPTS)) < 0) 
	{
		printf("socket %s",location);
		return 0;
	}
	(void) shutdown(d, 0);
	/* bind it */
	bzero((caddr_t)&sin, sizeof(sin));
	sin.sin6_family = AF_INET6;
	sin.sin6_len = sizeof(sin);
	COPY_ADDR6(*src, sin.sin6_addr);
	if (bind(d, (struct sockaddr *)&sin, sizeof(sin)) < 0) 
	{
		printf("bind %s",location);
		(void) close(d);
		return 0;
	}
	/* connect it */
	COPY_ADDR6(*dst, sin.sin6_addr);
	if (connect(d, (struct sockaddr *)&sin, sizeof(sin)) < 0) 
	{
		printf("connect %s",location);
		(void) close(d);
		return 0;
	}
	/* send */
	cc = write(d, buffer, size);   
	if (cc != size)
	{
		printf("write %s",location);
	    return 0;
	}
	(void) close(d);
	return 1;
}
