/* share between UHMMA and uMIP */
#if defined (MOBILE) && (UHMMA) || (uMIP)

#include "ndpd.h"
#include "../ndpd-uhmma/uhmma.h"

/*
just a simple function to
check if the prefix of a is the same that the prefix of b, 
len is the prefix length, so the check is done on len bytes.

called by : send_bnd_upd (for UHMMA), recv_uhmma_reg
call :
*/
char same_prefix(a,b,len)
struct in6_addr * a;	/* first address to compare */
struct in6_addr * b;	/* second address to compare */
int len;		/* the prefix length */
{
    int i;
    
    for(i=0 ;i<len ;i++ )
	if(a->s6_addr[i] != b->s6_addr[i]) 
	    return KO;
    return OK;
}



/*
an other simple function to check if to ipv6 addresses
have the same eui64

called by : send_uhmma_minor_reg 
call :
*/
char same_eui64(a,b) 
struct in6_addr * a;	/* first address to compare */
struct in6_addr * b;	/* second address to compare */
{
    int i;
    
    for (i=8; i<16;i++)
	if(a->s6_addr[i] != b->s6_addr[i]) 
	    return KO;
    return OK;
}
#endif