/*

MA annonce stuff

MA send their address on the virtual network to all BS 

*/

#ifdef uMIP

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"
/*
send a packet witch contain the MA data to all the BS of the site.
the date is in a destination option MA address.
it contains :
- the address on the virtual interface
- the mode
- the prefix length of the virtual prefix

this function must be called by a MA.

the use of a new kind of option doesnt work, because the kernel of the
destination drops the packet. I will use a Breq with a sub option MA annonce.

todo : create the new king of destination option, and hack the kernel.

the very first call to this function is "done" in mobility_init. 
in this function we are not sure that all the initialization process is done.
so we start the retransmission process with a very short time.


called by : run_timeouts
call : send_kernel
*/
void send_MA_annonce(clear)
char clear;
{
	struct in6_addr addr;
	register u_char *cp;
	char bubuf[24];
	char mode;
	u_char plen;
	struct BaseStation * bs;

	if(! SAME_ADDR6(MA_address, listMA.tqh_first->addr))
	    return;
	    	
	if(clear != 0)
	{
	    CLR_ADDR6(addr);
	    mode = 0;
	    plen=0;
	}
	else
	{
	    COPY_ADDR6(MA_address,addr);
	    mode = MA_op;
	    plen = VirtualNetwork.plen;
	}

	/*
	    fill a MA address in a destination option
	 */
	cp = (u_char *)bubuf;

	SET8(IP6_NHDR_NONH, cp);
	SET8(2, cp);

	SET8(OPT6_BINDING_REQ, cp);
	SET8(20, cp);
	/*SUB OPTION MA*/
	SET8(SUB_OPT6_MA, cp);
	SET8(18, cp);
	SET8(MA_op, cp);	/* mode */
	SET8(plen, cp);		/* pref len */
	SETADDR(addr, cp);
	/* send */
	FORALLBS(bs)
	{
	    if(send_kernel("send MA annonce",bubuf,sizeof(bubuf),
			&ME,&bs->addr,0,0) == 0)
		return;
	    if (verboseU) 
		logtrace("\tuMIP ; sent MA annonce to %s",
				 inet6pr(&bs->addr));
	}
	/* restart timer */	
	if(clear == 0)
	    set_timeout(MA_annonce_timer, temp.annonce, 0, \
		    (func_to) send_MA_annonce, 0);

}
#endif
