#ifdef uMIP

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"

void kill_MA(struct MobilityAgent * );

void update_MA(addr,charge)
struct in6_addr * addr;		/* the ma address */
u_short charge;			/* the ma charge */
{
    struct MobilityAgent * ma;
    struct MobilityAgent * ma2;
    
    /* look for the ma */
    FORALLMA(ma)
	if(SAME_ADDR6(ma->addr,*addr))
	    break;

    /* this is a new ma */
    if(ma == NULL)
    {
	struct MobilityAgent * newma;
	struct timeout * tt;
	
	newma = malloc(sizeof(struct MobilityAgent));
	tt = malloc(sizeof(struct timeout));
	if((newma==NULL)||(tt==NULL))
	{
	    if(verboseU)
		logtrace("\tuMIP ; not enough memory to store ma list");
	    return;
	}
	set_timeout(tt,DEFAULT_MA_LIFETIME,0,(func_to)kill_MA,newma);
	newma->charge = charge;
	COPY_ADDR6(*addr,newma->addr);
	newma->life = tt;
	ma = newma;
	if(verboseU)
	    logtrace("\tuMIP ; add a new MA");
	goto insert;
	return;
    }
    
    /* we already have this ma */
    /* refresh the ma record */
    RESTART_TIMER(ma->life,DEFAULT_MA_LIFETIME,(func_to)kill_MA,ma);

    /* check if the chare has changed */
    if(ma->charge != charge)
    {
	if(verboseU)
	    logtrace("\tuMIP ; update a MA");
	TAILQ_REMOVE(&listMA, ma, ma_next);
	ma->charge = charge;
insert:
	if(
	   (listMA.tqh_first == NULL) ||
	   (ma->charge < listMA.tqh_first->charge) 
	  )
	{
	    TAILQ_INSERT_HEAD(&listMA,ma,ma_next);
	    return;
	}

	FORALLMA(ma2)
	    if(ma2->charge > ma->charge)
		break;
	
	if(ma2 == NULL)
	{
	    TAILQ_INSERT_TAIL(&listMA,ma,ma_next);	
	    return;
	}
	
	TAILQ_INSERT_BEFORE(ma,ma2,ma_next);
	return;
    }
    

}

void kill_MA(ma)
struct MobilityAgent * ma;
{
    if(verboseU)
	logtrace("\tuMIP ; kill a MA");
    ma->life->refcnt =0; /* to free it */
    TAILQ_REMOVE(&listMA, ma, ma_next);
    free(ma);
}


#endif
