#ifdef uMIP

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"
/*
add a correspondent node to the list of cn of this mh.
we use the ha structure to initialize fields of the new structure.

called by : recv_bpf
call : same_prefix
*/
struct corr * add_corr(ad_corr,mob)
struct in6_addr * ad_corr;		/* cn address */
struct mobile * mob;			/* the mobile host */
{
    struct corr * cop;
    struct corr * hagent = mob->HomeAgent;
    
	if((Calloc(cop, corr) == NULL))
	{
	    if(verboseU)
		logerr("not enough memory to store cn structure");
	    return;
	}
	COPY_ADDR6(*ad_corr, cop->addr);
	COPY_ADDR6(hagent->careof, cop->careof);
	COPY_ADDR6(hagent->home, cop->home);
	COPY_ADDR6(hagent->VCOA, cop->VCOA);
	cop->flags = 0x20;	/* flags : C*/
	cop->seq = 0; 
	cop->lifetime = mob->lifetime;
	cop->plen = VirtualNetwork.plen;
	cop->tp = NULL;
    if(same_prefix(ad_corr,&VirtualNetwork.pref,site_len)==0)
	cop->type = VCOA_NEEDED;
    else
	cop->type = NO_VCOA_NEEDED;
	
	TAILQ_INSERT_TAIL(&mob->CH, cop, cr_list);

    if(verboseU)
	logtrace("\tuMIP ; add %s for %s",
		inet6pr(&cop->addr),inet6pr(&cop->home));
    return cop;
}

#endif