/* 
MA old position stuff 
*/

#ifdef uMIP

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"

/*
a registered mobile host stays in the domain.
it confirms that it is here.
the ma has to restart the timer for this MH.

the MH is acknowledged only if the process goes wrong.

called by : recv_destopt
call : send_bnd_ack,
*/
void recv_old_position(ip, cp, careof)
struct ip6_hdr *ip;			/* the ip header */
u_char *cp;					/* the option ; the BU*/
struct in6_addr *careof;	/* the coa for this mobile */
{
	register struct mobile *mop;
	u_char flags, plen, status = OPT6_BNDA_ACCEPT;
	u_short seq;
	u_int life;
	struct in6_addr *home, *tmp;

	(void)gettimeofday(&now, NULL);

	/* decode the binding update */
	home = &ip->ip6_src;
	GET8(flags, cp);
	GET8(plen, cp);
	GET16(seq, cp);
	GET32(life, cp);
/*	if (flags & OPT6_BNDU_COA) {
		tmp = (struct in6_addr *)cp;
		if (verboseU && !IN6_ARE_ADDR_EQUAL(tmp, careof))
			logtrace("real careof is %s", inet6pr(tmp));
		careof = tmp;
	}
*/
	if (verboseU) {
		logtrace("\tuMIP ; received old position from "
			 "(home) %s seq#%d",
			 inet6pr(home), seq);
	}

	/* look for a mobile entry */
	FORALLMAMH(mop)
		if (IN6_ARE_ADDR_EQUAL(home, &mop->home) )
			break;
	/* got a mobile entry */
	if (mop) 
	{
	    if (verboseU)
	    	logtrace("\tuMIP ; find mop ");
	    /* check sequence number */
	    if (!SEQ_GT(seq, mop->seq)) 
	    {
	        if (verboseU)
	    	    logerr("bad sequence (%d !GT %d)",
			       (int)seq, (int)(mop->seq));
			send_bnd_ack(mop,OPT6_BNDA_UNSPEC,0);
			return;
	    }
	    /* update sequence # */
	    mop->seq = seq;

	    /* restart the mobile timer, reuse the old one 
		just kill it with a refcnt > 0 to remove it from the list
		not freed it
	    */
	    RESTART_TIMER(mop->position_timer,life,kill_mobile,mop);
	}
	/* the mobile host is not registered */
	else
	{
	    struct mobile mh;
	    COPY_ADDR6(*careof,mh.careof);
	    if(verboseU)
		logerr("\tuMIP ; reveided an old position BU for an unregistered mobile ");
	    send_bnd_ack(&mh,OPT6_BNDA_REFUSED,0);
	}

}

#endif
