/* 
a MH was managed by a MA.
the mh moved to an other domain.
the pursuit is the action to update MH structure and tunnel to forward
packet witch are destined to the old vcoa to the new vcoa.

this function is called by the forwarding process and the smooth process
(mode 1 / mode 2)

 */

#ifdef uMIP
#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"

#include "../ndpd-uhmma/uhmma.h"

/*
firstly check if the mobile structure exist, else send back to sender.

this MH was here but is gone.
we have to update is coa and change its tug to its new position 
and to restart the timer for the last time because the MH will no 
longer send old position packet.

called by : recv_smooth, recv_forward
call :
*/
char mobile_forward(mop, seq,life,MA,careof)
struct mobile * mop;		/* address of the mobile host structure */
int seq;			/* seq number of the forward request */
int life;			/* lifetime of the forward request */
struct in6_addr *MA;		/* the sender */
struct in6_addr *careof;	/* the new position of the mobile host */
{
    /* got a mobile entry */
    if (mop) 
    {
	if (verboseU)
	    logtrace("\tuMIP ; find mop address %s", 
			    inet6pr(&mop->home));

	/* check sequence number ; note that retransmissions must increment seq# */
	if (seq <= mop->seq)
	{
    	    struct mobile mh;
    	    if (verboseU)
		logerr("bad sequence (%d !GT %d)",
		       (int)seq, (int)(mop->seq));
	    bcopy(mop,&mh,sizeof(struct mobile));
	    COPY_ADDR6(*MA, mh.me);
	    send_bnd_ack(&mh,OPT6_BNDA_UNSPEC,0);
	    return 0;
	}
	mop->seq = seq;
	mop->lifetime = life;
	
	/* check if MH has really moved or if its MA resends smooth
	   handoff request
	 */
	if (! SAME_ADDR6(*careof, mop->careof)) 
	{
	    /* kill the tunnel to the old coa */
	    del_tunnel(mop);
	    /* store the new coa */
	    COPY_ADDR6(*careof, mop->careof); 
	    /* create a tunnel to the new coa */
	    add_tunnel(mop);
	    if(verboseU)
		logtrace("\tuMIP ; tug updated");
	}

	mop->dereg =0;	/* no de registration */
    /* restart the mobile timer, 
       when the mobile host's lifetime will be done, we will not send
       de registration (only mode 2)
    */
	RESTART_TIMER(mop->position_timer,life, kill_mobile,mop);
	if(verboseU)
	    logtrace("\tuMIP ; restart the MH timer for the last time %d",
			life);
	return 1;
    }
    /* the mobile is not registered */
    else
    {
	return 0;
    }
}
#endif
