/* mobile registration in the local MA
    
    MA
*/

#ifdef uMIP

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"

#include "../ndpd-uhmma/uhmma.h"

struct in6_addr buildVCOA(struct in6_addr * COA);
void kill_cn_list(struct mobile *);

/*
decode the registration packet.

check the type n the length of the sub-option, if they suck just send back
else register the mh n send a BACK to the mh.

called by : recv_dest_op
call : send_bnd_back, new_timeout, kill_cn_list, kill_mobile, send_home_reg,
       send_bnd_upd, same_prefix, add_tunnel, del_tunnel, del_binding, add_binding
       build_VCOA, send_forward, send_smooth
*/
void recv_uhmma_reg (ip, upd, careof)
struct ip6_hdr * ip;		/* the ip header */
u_char ** upd;			/* the first destination option = BU */
struct in6_addr *careof;	/* the coa (ie. the source) */
{
    struct in6_addr MAold;
    struct in6_addr HomeAgent;
    struct in6_addr VCOA;
    struct mobile * mh;
    struct in6_addr * haddr;
    char flags, type;
    char blen, plen, slen, pad;
    short seq;
    int life;
        
    blen = *(*upd-1);
    /* decode BU */
    GET8(flags, *upd); /* contains the requested mode */
    GET8(plen, *upd);  /* contains zero */
    GET16(seq, *upd);
    GET32(life, *upd);
    haddr = &ip->ip6_src;
    /* check if the packet is a full registration (with MA and HA suboptions) */    
    if(blen == 8)
	goto notfull;
    /* decode MAold */
    GET8(type, *upd);
    GET8(slen, *upd);
    if((type != SUB_OPT6_MA)||(slen != 22))
    {
		struct mobile mop;
		if (verboseU)
		    logtrace("\tuMIP ; registration packet received with a buggy MA sub-option");
		COPY_ADDR6(ip->ip6_dst,mop.me);
		COPY_ADDR6(ip->ip6_src,mop.careof);
    		send_bnd_ack(&mop, OPT6_BNDA_UNSPEC, 0);
		return;
    }    
    GET8(pad, *upd);
    GET8(pad, *upd);
    GETADDR(MAold, *upd);
    GET32(pad, *upd);

    /* decode HA */
/*    GET8(type, *upd);
    GET8(slen, *upd);
    if((type != SUB_OPT6_HA)||(slen !=UHMMA_HA_SUBO_LENGTH))
    {
        struct mobile mop;
        if (verboseU)
            logtrace("\tuMIP ; registration packet received with a buggy HA sub-
option");
        COPY_ADDR6(ip->ip6_dst,mop.me);
        COPY_ADDR6(ip->ip6_src,mop.careof);
        send_bnd_ack(&mop, OPT6_BNDA_FORMAT, 0);
        return;
    }
    GET8(pad, *upd);
    GET8(pad, *upd);
    GETADDR(HomeAgent, *upd);
*/
    if (verboseU)
	logtrace("\tuMIP ; receive UHMMA reg from %s\n\thome = %s, seq#%d",
		    inet6pr(careof),inet6pr(haddr),seq);
notfull:
    
    /* find if the mobile is already registered */
    FORALLMAMH(mh)
	if(SAME_ADDR6(mh->home,*haddr)) 
	    break; /* we 've got it */


    /* a registration with a length of 32 is only accepted if the mobile host :
	  - is already registered
    note that the registration packet length is 32
    but the bu option length is 8
    */
    if(blen == 8)
    {
	if(
	    (mh == NULL)
	  )
	{
    	    if(verboseU)
    		logtrace("\tuMIP ; illegal registration format");
	    return;
	}
    }

    /* -------------------------------------
    
	the mh is already registered 
    
    ---------------------------------------*/
    if(mh != NULL)
    {
	/* cleanup */
    	if(life == 0)
	{
	    if(verboseU)
		logtrace("\tuMIP ; clean up case");
	    kill_mobile(mh);
	    return;
	}
	/* check the sequence number */
	if(seq <= mh->seq)	/* the retransmission seq# must be ++ed by the mobile host */
	{
	    if(verboseU)
		logtrace("\tuMIP ; seq# too small");
    	    send_bnd_ack(mh, OPT6_BNDA_ADMIN, 0);
	    return;
	}
	mh->seq = seq;
	/* ------------------------------------------------------
	    no movement performed, the BACK was lost
	    
	    find the kind of the last movement 
		 - last movement = micro mobility 
		    just resend the back n restart the mobile timer
		 - last movement = macro mobility 
		    resend the back n restart the mobile timer
		    if uMIP MODE 2 we may need to resend a home reg to the HA 
		    to force the HA to resend a BACK to the mobile host
			note : if the MH is coming from an other network
			we have started a smooth handoff process and we are
			waiting for the cn list, so we don't have the HA
			structure yet ; do not send home registration

	---------------------------------------------------------*/
	if(SAME_ADDR6(mh->careof, *careof))
	{
	    if(blen == 8)
	    {
			if(verboseU)
			    logtrace("\tuMIP : received a registration without MA");
			/* update mobile host structure */
			mh->seq = seq;
			RESTART_TIMER(mh->position_timer,life,kill_mobile,mh);

			return;
	    }
	    /* macro mobility */
	    if(! SAME_ADDR6(MAold, MA_address))
		if((flags==2)&&(MA_op == 2))
		{
		    if(verboseU)
				logtrace("\tuMIP : problem during registration process, restart it");
		    /* we have the HA structure, one back may be lost ?? */
		    if(mh->HomeAgent != NULL)
		    {
				mh->HomeAgent->flags |= OPT6_BNDU_ACK;
				send_home_reg(mh->HomeAgent);
				mh->HomeAgent->flags &=~OPT6_BNDU_ACK;
		    }
		    /* we don't have the HA structure, smooth handoff in
		       progress ?
		     */
		    else
		    {
				struct WBACK *wb;
				FORALLWB(wb)
				    if(SAME_ADDR6(wb->MH->home,mh->home))
						break;
				/* procede to smooth handoff */	
				if(wb == NULL)
				    send_smooth(&MAold, mh);
		    }
		}
	}
	/* -----------------------------------------------
	
	a movement was performed; it could be 

	   - a micro mobility movement 
	        we have to change the tug to the new coa
		restart the mobile timer
		update the kernel binding
		if mode 2
		    send binding update to all local CH
	   - a return to home movement (major move)
	       we have to change the tug to the mobile host's H@ 
	       restart the mobile timer (it ll be the last)
	       remove the kernel binding
	       if mode 2
	           send binding update to all CH

	---------------------------------------------------*/
	else
	{
	    /* kill the tunnel to the old coa */
	    del_tunnel(mh);
	    /* store the new coa */
	    COPY_ADDR6(*careof, mh->careof); 
	    /* create a tunnel to the new coa */
	    add_tunnel(mh);
	    /* restart the mobile timer */
	    RESTART_TIMER(mh->position_timer,life,kill_mobile,mh);
		mh->lifetime = life;

	    /*---------------------------
	            back to home 
	    ---------------------------*/
	    if(SAME_ADDR6(mh->careof,mh->home))
	    {
			if(verboseU)
			    logtrace("\tuMIP ; the mobile is back to its home");
			if((MA_op == 2)&&(flags==UHMMA_MODE2))
			{
			    /* synchronize the ha seq number */
			    /* note : the HA is always the first cn in the list */
			    mh->CH.tqh_first->seq = mh->seq;
			    /* remove all cn for this mobile host and send de registration */
			    kill_cn_list(mh);
			}
			/* remove kernel binding */
			del_binding(mh);
			/* 
			   do not send de registration when remove it.
			   abuse because kill_cn_list remove all cn
			 */
			mh->dereg =0;
	    }
	    /*---------------------
	        micro mobility 
	    ----------------------*/
	    else
	    {
			struct corr * cop;
			if(verboseU)
			    logtrace("\tuMIP ; the mobile performed a micro movement");
			if((MA_op == 2)&&(flags==UHMMA_MODE2))
			    /* send BU to all local CH */
	    	    FORALLMHCORR(mh, cop) 
				/* do not send BU to the HA */
			if(!(cop->flags  & OPT6_BNDU_HR))
			if(same_prefix(&mh->careof,&cop->addr,site_len))
			{
			    /* update coa */
			    COPY_ADDR6(*careof,cop->careof);
			    send_bnd_upd(cop);
			}
			/* update kernel binding */
			del_binding(mh);
			add_binding(mh);
	    }
	}
	    /*--------------------------------------------------
		common stuff for a registered mobile host
	    ---------------------------------------------------*/
	    /* send back */
	    mh->seq = seq;
	    send_bnd_ack(mh, OPT6_BNDA_ACCEPT, temp.refresh);
	
	return;
    }
    /* --------------------------------------
    
	this mobile is not yet registered ,
	it is coming from an other domain

	we have to create a structure to store this mobile

    -----------------------------------------------*/
    else
    {
	struct mobile * mob;
	struct prefix *pp;

	/* cleanup */
    	if(life == 0)
	{
	    if(verboseU)
		logtrace("\tuMIP ; clean up ????");
	    return;
	}
	/* a curious case ; check if we are the previous MA ? */
	if(SAME_ADDR6(MAold,MA_address))
	{
	    if(verboseU)
		logtrace("\tuMIP ; I'am the previous MA ??");
	    return;
	}
	/* check if the needed mode is available */
	if (flags == UHMMA_MODE2) 
	    if (MA_op == UHMMA_MODE1) 
	    {
		struct mobile dst;
		if(verboseU)
		    logtrace("\tuMIP ; MH need mode 2, but only mode 1 is available");
		COPY_ADDR6(*careof,dst.careof);
		dst.seq=seq;
		send_bnd_ack(&dst,OPT6_BNDA_MODE,temp.refresh);
		return;
	    }

	if((Calloc(mob, mobile) == NULL))
	{
	    if(verboseU)
		    logerr("\tuMIP ; not enough memory to store mobile structure");
	    return;
	}
	if(verboseU)
		logtrace("\tuMIP ; this is a new mobile host ");
	VCOA = buildVCOA(careof);
	/* build the mobile structure */
	COPY_ADDR6(*haddr, mob->home);
	COPY_ADDR6(*careof, mob->careof);
	COPY_ADDR6(VCOA, mob->VCOA);
	COPY_ADDR6(ip->ip6_dst, mob->me);
	mob->dereg =1;
	mob->refresh = temp.refresh;
	mob->lifetime = life;
	mob->plen = plen;
	mob->seq = seq;
	mob->pp = VirtualNetwork.pp;
	mob->HomeAgent = NULL;

	/* store the mobile structure in the mobile list */
	TAILQ_INSERT_TAIL(&listMH, mob, mb_list);
	/* proxy stuff */
	if(add_tunnel(mob)!=OPT6_BNDA_ACCEPT)
	{
	    if(verboseU)
		logtrace("\tuMIP ; problem while opening tug to the mobile");
	    /* binding ack */
	    send_bnd_ack(mob, OPT6_BNDA_RES, mob->refresh);
	    /* remove n free the mobile record */
	    TAILQ_REMOVE(&listMH, mob, mb_list);
	    free(mob);
	    return;
	}
	add_binding(mob);
	
	/* ---------------------------------------------------
	
	    the mobile is coming from its home network 
	    
	    send back to the mobile
	    if uMIP mode 2
		start the correspondent nodes list with the HA
		send home registration to the HA
	
	------------------------------------------------------*/	
	if(IS_ANYADDR6(MAold))	
	{
	    if(verboseU)
		logtrace("\tuMIP ; this mobile host is coming from its home network");
	    /* --------------------------------------------
		the mobile host needs mode2
	    -------------------------------------------- */
	    if((flags==UHMMA_MODE2)&&(MA_op == UHMMA_MODE2))
	    {
		struct corr * hagent;

		if((Calloc(hagent, corr) == NULL))
		{
		    if(verboseU)
			logerr("not enough memory to store hagent structure");
		    /* send back */
		    send_bnd_ack(mob, OPT6_BNDA_RES, mob->refresh);
		    /* remove n free the mobile record */
		    TAILQ_REMOVE(&listMH, mob, mb_list);
		    free(mob);
		    return;
		}
		mob->HomeAgent = hagent;
		/* built the HA structure */
		TAILQ_INIT(&mob->CH);
		COPY_ADDR6(HomeAgent, hagent->addr);
		COPY_ADDR6(*careof, hagent->careof);
	        COPY_ADDR6(*haddr, hagent->home);
		COPY_ADDR6(VCOA, hagent->VCOA);
		hagent->flags = 0xe0;	/* flags : AHC*/
		hagent->seq = seq-1; 	/* -1 because send_home_reg does ++ */
		hagent->lifetime = life;
		hagent->plen = VirtualNetwork.plen;
		hagent->tp = NULL;
		hagent->type = VCOA_NEEDED;
		TAILQ_INSERT_HEAD(&mob->CH, hagent, cr_list);
		/* HA home registration */
		send_home_reg(hagent);
		
		charge +=2;
	    }
	    /* --------------------------------------------
		common stuff for mode 1 and 2
	    -------------------------------------------- */
	    /* start the life timer for this mobile */
	    mob->position_timer=new_timeout(life, 0, (func_to)kill_mobile,
	    				    mob);
	    charge +=1;
	    update_MA(&MA_address,charge);
	}
	/* ----------------------------------------------
	
	    the mobile is coming from an other network 
	
	------------------------------------------------*/
	else
	{
	    if(verboseU)
		logtrace("\tuMIP ; this mobile is coming from an other network (not its home network");
	    if((flags==2)&&(MA_op == 2))
	    {
		/* procede to smooth handoff */	
		send_smooth(&MAold, mob);
		return;
	    }
	    else
	    {
		charge +=1;
		update_MA(&MA_address,charge);
		send_forward(&MAold,mob);
		/* start the life timer for this mobile */
		mob->position_timer=new_timeout(life, 0, (func_to)kill_mobile,
	    				    mob);
	    }
	}
	/* binding ack 
	    if the mobile host is coming from a MIP domain,
	    we must not send back now, we have to wait for the cn list
	*/
	if(flags != UHMMA_MODE2_FROM_MIP)
	    send_bnd_ack(mob, OPT6_BNDA_ACCEPT, mob->refresh);
	else
	    if(verboseU)
	        logtrace ("\tuMIP ; this mobile host is coming from a MIP/UHMMA1 domain");
    }
}
/*
remove a mobile structure from the managed mobile hosts list, 
stop and free associated timers,
remove the kernel binding.

if running uMIP2
  remove all timer for sending BU to the CH and 
  clear CH records 

called by : recv_uhmma_reg, run_timeout, recv_forward, recv_smooth
call :
*/
void kill_mobile(mob)
struct mobile * mob;	/* the mobile host */
{
    struct WBACK * wb;
    if(verboseU)
	logtrace("\tuMIP ; remove mobile %s",
		    inet6pr(&mob->home));
    charge -= (mob->CH.tqh_first==NULL?1:3);
    update_MA(&MA_address,charge);
    /* remove n free all CH and send de registration */
    if(mob->CH.tqh_first != NULL)
	kill_cn_list(mob);
    /* stop associated timer 
       we check if the timer exist because sometime, we created
       and added the mobile structure without starting the old position
       process (ie. sending a smooth)
    */
    DESTROY_TIMER(mob->position_timer);
    /* stop proxy */
    del_tunnel(mob);
    /* remove kernel binding */
    del_binding(mob);
    /* check if a smooth handoff runs for this mobile host */
    FORALLWB(wb)
	if(wb->MH == mob)
	{
	    /* stop the timer */
	    DESTROY_TIMER(wb->tm);
	    /* remove the WBACK structure */
	    free(wb->pkt);
	    free(wb);
	    break;	/* only one smooth handoff per mobile host */
	}
    /* remove n free the mobile record */
    TAILQ_REMOVE(&listMH, mob, mb_list);
    free(mob);
}
/*
remove all cn of a mobile host, 
and stop/free the associated timers.
if dereg is set, we send a de registration to the cn (ie a registration 
with life = 0).

called by : kill_mobile, recv_uhmma_reg
call : send_bnd_upd, send_home_reg
*/
void kill_cn_list(mob)
struct mobile * mob;	/* the mobile host */
{
    struct corr * ch;
    struct corr * tmp;

    if(verboseU)
	logtrace("\tuMIP ; remove cn list for %s",
		    inet6pr(&mob->home));

        ch = mob->CH.tqh_first;
        while(ch != NULL)
        {
	    /* the ch timer might already have been destroyed by a smooth
	       handoff
	     */
	    DESTROY_TIMER(ch->tp);
	    /* send de registration */
	    if(mob->dereg == 1)
	    {
		ch->lifetime =0;
		ch->type = HOME_NEEDED;
		if(ch->flags & OPT6_BNDU_HR)
		    send_home_reg(ch);
		else
		    send_bnd_upd(ch);
	    }
	    
	    tmp = ch;
	    /* next one */
	    ch=ch->cr_list.tqe_next;
	    /* remove n free the CH record */
	    TAILQ_REMOVE(&mob->CH, tmp, cr_list);
	    free(tmp);
	}
}
/*
build a VCOA for a mobile.
VCOA = mobility network prefix + mobile EUI64

called by : recv_uhmma_reg
call :
*/
struct in6_addr buildVCOA(COA)
struct in6_addr * COA;
{
    /* todo : find a better way to build vcoa (ie support pref x) */
    struct in6_addr ta,mask;
    int i;
    char * ptr ="0:0:0:0:ffff:ffff:ffff:ffff";
    
    if (inet_pton(AF_INET6, ptr, &mask) <= 0)
    {
        if(verboseU)
    	    logperror("VCOA building problem");
	return;
    }
    COPY_ADDR6(*COA, ta);	/* ta=PCOA */
    for(i=0 ;i<16 ;i++ )
    {
	ta.s6_addr[i] &= mask.s6_addr[i];
    }				/* ta=eui64 */
    for(i=0 ;i<16 ;i++ )
    {
	ta.s6_addr[i] |= VirtualNetwork.pref.s6_addr[i];
    }				/* ta=VCOA */
    return ta;
}

#endif
