#ifdef uMIPBS

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#ifdef uMIPBS
#include "../ndpd-uhmma/uhmma.h"
#endif
#ifdef uMIP
#include "../ndpd-uhmma/uhmma.h"
#endif

void recv_MA_data(cp)
u_char *cp;		/* the destination option */
{
    if (BS_op == 1)
    {
	char type;
	char length;
	char pad;
	char mode;
	u_char plen;
	struct in6_addr ma;
    	
	if(verboseU)
	    logtrace("\tuMIP receive BReq with MA annonce");

	GET8(type, cp);
	GET8(length, cp);
	GET8(mode,cp);
	GET8(plen,cp);

	GETADDR(ma, cp);
	if(
	    (type != SUB_OPT6_MA)||(length!=18)
	    || ((mode !=1)&&(mode!=2)&&(mode!=0))
/*	    || (IS_ANYADDR6(ma))*/
	  )
	{
	    if(verboseU) logtrace("\tuMIP ; MA address sub option buggy : MA = %s, type = %d, mode = %d",inet6pr(&ma),type,mode);
	    return;
	}

	if(
	    (! SAME_ADDR6(ma, MA_info.MA_address)) 
	    || (mode != MA_info.mode)		   
	    || (plen != MA_info.plen)
	  )
        {
    	    COPY_ADDR6(ma, MA_info.MA_address);
	    MA_info.mode = mode;
	    MA_info.plen = plen;
	    if(verboseU) logtrace("\tuMIP ; MA changes to %s mode %d plen %d",
			inet6pr(&ma), mode,plen);
	}
	else
	{
	    if(verboseU) logtrace("\tuMIP ; MA doesn't change");
	}
    }
    else
    {
	if(verboseU)
	    logtrace("\tuMIP ; receive a MA address but not a BS");
    }

}
#endif