#ifdef UHMMA

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"




/*
A mobile host sends a forward packet to its previous MA, we it was
previously managed in mode1 and when it does not have a MA in it's 
new domain.
the forwarding asks to the previous ma to redirect packets to the
new coa of the mobile host (remember no MA here!)

called by : check_swap
call : send_kernel
*/
void send_forward(careof)
struct in6_addr * careof;
{
	int byte_length = 48;	/* must be a 8multiple */
	int byte_8_length = (byte_length -8) / 8;
	char bubuf[byte_length];
	register u_char *cp;

	/* update the seq# */
	global.seq_num ++;

	/* build the packet */
	cp = (u_char *)bubuf;

	SET8(IP6_NHDR_NONH, cp);
	SET8(byte_8_length, cp);
	/* DO BU  */
	SET8(OPT6_BINDING_UPD, cp);
	SET8(24, cp);
	SET8(FORWARD_FLAG|0x20, cp);/* coa in the BU */
	SET8(0, cp);
	SET16(global.seq_num, cp);
	SET32(temp.forward, cp);
	SETADDR(*careof, cp);

	SET8(OPT6_PAD_0, cp);
	SET8(OPT6_PAD_0, cp);

	/* DO H@ */
	SET8(OPT6_HOME_ADDR, cp);
	SET8(16, cp);
	SETADDR(global.HA->home, cp);

	/* send */
	if(send_kernel("send forward",bubuf,byte_length,
	               careof,&global.MA_old,1,0) == 0)
	    return;
	if (verboseU) 
		logtrace("\tUHMMA ; send forward to %s for %s",
				 inet6pr(&global.MA_old),inet6pr(&global.HA->home));
}
#endif