#ifdef UHMMA

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"


/*
build n send an 'old position' packet (ie a BU with the OLD_POSITION_FLAG).
the packet is sent to the local MA, of course. 
uMIP_timer is triggered again.

called by : run_timeout (because uMIP_timer expires), send_paging
call : set_timeout
*/
void send_old_position ()
{
	register u_char *cp;
	char bubuf[32];
	
	/* update the sequence# */
	global.seq_num ++;

	/*
	 * Fill a destination option header with the binding update
	 * and a home address options.
	 */

	cp = (u_char *)bubuf;

	SET8(IP6_NHDR_NONH, cp);
	SET8(3, cp);
	SET8(OPT6_PAGING_UPD, cp);
	SET8(8, cp);			/* length of the option */
	SET8(OLD_POSITION_FLAG, cp);	/* flag = old position BU */
	SET8(0, cp);			/* prefix length ??? */
	SET16(global.seq_num, cp);
	SET32(temp.lifetime, cp);

	SET8(OPT6_PAD_0, cp);
	SET8(OPT6_PAD_0, cp);

	SET8(OPT6_HOME_ADDR, cp);
	SET8(16, cp);
	SETADDR(global.HA->home, cp);

	/* send */
	if(send_kernel("send old position",bubuf,sizeof(bubuf),
			&global.HA->careof,&global.MA_address,0,0)==0)
	    return;
	if ((verboseU) 
	    )
		logtrace("\tUHMMA ; sent old position BU to %s",
				 inet6pr(&global.MA_address));

	/* restart timer	*/
	{
	    RESTART_TIMER(global.uMIP_timer,temp.position,send_old_position, NULL);
	    if(verboseU)
		logtrace("\tUHMMA ; timer uMIP re started %x",global.uMIP_timer);
	}
}
#endif
