/* mobile BU stuff hacked for UHMMA */

#if defined (MOBILE) && (UHMMA)

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"
#include "../ndpd-uhmma/uhmma.h"

void force_nd(struct corr *);
struct interface * home_if(struct corr *);

/*
replace the MIPv6 send_bnd_upd

called by : major_move, minor_move, mobile_move
call : send_kernel
*/
void send_bnd_upd(cop)
struct corr *cop;	/* the cn destination */
{
	register u_char *cp;
	char bubuf[56];
	char vcoa = !IS_ANYADDR6(cop->VCOA);
	int len = (vcoa ? 56 :32);
	
	if (verboseU) 
	{
		logtrace("will send binding update");
		logtrace("addr=%s", inet6pr(&cop->addr));
		logtrace("home=%s", inet6pr(&cop->home));
		logtrace("flags=%x [%s] life=%u seq=%d retcnt=%d",
			 cop->flags, bnd_upd_flg(cop->flags),
			 cop->lifetime, cop->seq, cop->retcnt);
	}
	
	if((verboseU)&&(vcoa))
	    logtrace("\tUHMMA ; need to put VCOA in the BU");
	/*
	 * Fill a destination option header with the binding update
	 * and a home address options.
	 */

	cp = (u_char *)bubuf;

	SET8(IP6_NHDR_NONH, cp);
	if(vcoa)
	{
	    SET8(6, cp);
	    SET8(OPT6_BINDING_UPD, cp);
	    SET8(28, cp);
	    SET8(cop->flags, cp);
/*	    SET8(cop->flags|0x20, cp);*/
	    SET8(0, cp);
	    SET16(cop->seq, cp);
	    SET32(cop->lifetime, cp);
		/* care-of sub option */
		SET8(MOB6_SUBOPT_PAD1, cp);
		SET8(MOB6_SUBOPT_PAD1, cp);

		SET8(MOB6_SUBOPT_COA, cp);
		SET8(16, cp);
		SETADDR(cop->VCOA, cp);

		SET8(OPT6_PAD_N, cp);
		SET8(4, cp);
		SET32(0, cp);
	}
	else
	{
	    SET8(3, cp);
	    SET8(OPT6_BINDING_UPD, cp);
	    SET8(8, cp);
	    SET8(cop->flags, cp);
	    SET8(0, cp);
	    SET16(cop->seq, cp);
	    SET32(cop->lifetime, cp);

		SET8(OPT6_PAD_1, cp);
		SET8(OPT6_PAD_1, cp);
	}

	SET8(OPT6_HOME_ADDR, cp);
	SET8(16, cp);
	SETADDR(cop->home, cp);


	/* send */
	if(send_kernel("send binding update",bubuf,len,
			&cop->careof,&cop->addr,1,0)==0)
	    return;
	if (verboseU) 
	{
	    if(vcoa)
		logtrace("care-of=%s", inet6pr(&cop->VCOA));
	    else
		logtrace("care-of=%s", inet6pr(&cop->careof));
	    logtrace("sent binding update to %s", inet6pr(&cop->addr));
	}
}

/*
replace the MIPv6 send_home_reg

check if the mobile is running UHMMA, 
in UHMMA we always add a VCOA in the BU

called by : mobile_move, major_move, minor_move
call : send_kernel
*/
void send_home_reg(agp)
struct corr *agp;	/* the home agent */
{
    /* todo : do not insert the coa if not needed */
	register u_char *cp;
	char bubuf[56];
	struct in6_addr source;	/* address source */

	if (verboseU) {
		logtrace("will send home registration (add)");
		logtrace("home=%s", inet6pr(&agp->home));
		logtrace("addr=%s", inet6pr(&agp->addr));
		logtrace("flags=%x [%s] life=%u seq=%d retcnt=%d",
			 agp->flags, bnd_upd_flg(agp->flags),
			 agp->lifetime, agp->seq, agp->retcnt);
	}
	/*
	 * Fill a destination option header with the home registration
	 * and the home address options.
	 */

	cp = (u_char *)bubuf;

	SET8(IP6_NHDR_NONH, cp);

	SET8(6, cp);
	SET8(OPT6_BINDING_UPD, cp);
	SET8(28, cp);
/*	SET8(agp->flags|0x20, cp);*/
	SET8(agp->flags, cp);
	SET8(0, cp);
	SET16(agp->seq, cp);
	SET32(agp->lifetime, cp);

	SET8(MOB6_SUBOPT_PAD1, cp);
	SET8(MOB6_SUBOPT_PAD1, cp);

	SET8(MOB6_SUBOPT_COA, cp);
	SET8(16, cp);
	if(global.mobility_mode > MIP_MODE)
	{
		SETADDR(agp->VCOA, cp);
	}
	else
		SETADDR(agp->careof, cp);

	SET8(OPT6_PAD_N, cp);
	SET8(4, cp);
	SET32(0, cp);

	SET8(OPT6_HOME_ADDR, cp);
	SET8(16, cp);
	SETADDR(agp->home, cp);

	/* back to the home network */
	if(SAME_ADDR6(agp->careof, agp->home))
	{
	    struct interface *itf;
	    
	    force_nd(agp);
	    itf = home_if(agp);
	    if(itf == NULL)
		return;
/*	    COPY_ADDR6(itf->llocal,source);*/
/*	    COPY_ADDR6(agp->home,source);*/
	    CLR_ADDR6(source);
	    mdel_tunnel(agp);
	    agp->retcnt = 0;
	}
	/* no home network */
	else
	{
	    COPY_ADDR6(agp->careof,source);
	    /* setup tunnel */
	    if (agp->retcnt == 0)
		madd_tunnel(agp);
	}
	/* send */
	if(send_kernel("send binding update",bubuf,sizeof(bubuf),
			&source,&agp->addr,1,0)==0)
	    return;
	if (verboseU) 
	{
		if(global.mobility_mode>MIP_MODE)
		    logtrace("care-of=%s", inet6pr(&agp->VCOA));
		else
		    logtrace("care-of=%s", inet6pr(&agp->careof));
		logtrace("sent home registration (add) to %s",
				 inet6pr(&agp->addr));
	}
}

void force_nd(agp)
struct corr *agp;
{
	register char *cp;
	register struct router *rp;
	struct homeaddr *hap;
	struct sockaddr_in6 *sin;
	struct sockaddr_dl *sdl;
	int len, type = RTM_ADD;

	FORALLHA(hap)
		if (IN6_ARE_ADDR_EQUAL(&agp->home, &hap->addr))
			break;
	if (hap == NULL) {
		if (verbose)
			logerr("force_nd: can't find the home address %s",
			       inet6pr(&agp->home));
		return;
	}
	if (HAPP(hap) == NULL) {
		if (verbose)
			logtrace("force_nd: no home prefix");
		return;
	}
	if (HAPP(hap)->mflags & MOB_ISFA) {
		if (verbose)
			logerr("force_nd: home prefix is fake");
		return;
	}
	if (HAPP(hap)->plen == 128) {
		if (verbose)
			logtrace("force_nd: home prefix length is 128");
		return;
	}
	if (HAPP(hap)->ifp == NULL) {
		if (verbose)
			logerr("force_nd: can't find interface for prefix %s",
			       inet6pr(&HAPP(hap)->addr));
		return;
	}
	if (!HAPP(hap)->ifp->hasphy) {
		if (verbose)
			logtrace("force_nd: no phy on interface %s",
				 HAPP(hap)->ifp->name);
		return;
	}
	FORALLRP(rp, HAPP(hap)->ifp)
		if (IN6_ARE_ADDR_EQUAL(&agp->addr, &rp->rta))
			break;
	if (rp == NULL) {
		if (verbose)
			logtrace("force_nd: can't find home agent "
				 "%s as a router",
				 inet6pr(&agp->addr));
		return;
	}
	if (rp->phy.sdl_alen == 0) {
		if (verbose)
			logtrace("force_nd: home agent %s has "
				 "no physical address",
				 inet6pr(&agp->addr));
		return;
	}

	/* do the route! */

	(void) gettimeofday(&now, NULL);

    retry:

	bzero((caddr_t)&m_rtmsg, sizeof(m_rtmsg));
	rtm.rtm_version = RTM_VERSION;
	rtm.rtm_type = type;
	rtm.rtm_flags = RTF_UP | RTF_HOST;
	rtm.rtm_addrs = RTA_DST | RTA_GATEWAY | RTA_IFP | RTA_IFA;
	rtm.rtm_pid = pid;
	rtm.rtm_seq = ++rtm_seq;
	rtm.rtm_index = rp->ifp->index;
	rtm.rtm_rmx.rmx_expire = now.tv_sec + 5;
	rtm.rtm_inits = RTV_EXPIRE;

	cp = m_rtmsg.m_space;

	sin = (struct sockaddr_in6 *)cp;
	sin->sin6_len = sizeof(struct sockaddr_in6);
	sin->sin6_family = AF_INET6;
	COPY_ADDR6(rp->rta, sin->sin6_addr);
	ADVANCE(cp, sin);

	sdl = (struct sockaddr_dl *)cp;
	sdl->sdl_family = AF_LINK;
	sdl->sdl_len = sizeof(struct sockaddr_dl);
	sdl->sdl_index = rp->ifp->index;
	sdl->sdl_alen = rp->phy.sdl_alen;
	bcopy(LLADDR(&rp->phy), LLADDR(sdl), sdl->sdl_alen);
	ADVANCE(cp, sdl);

	sdl = (struct sockaddr_dl *)cp;
	sdl->sdl_family = AF_LINK;
	sdl->sdl_len = sizeof(struct sockaddr_dl);
	sdl->sdl_index = rp->ifp->index;
	ADVANCE(cp, sdl);

	sin = (struct sockaddr_in6 *)cp;
	sin->sin6_len = sizeof(struct sockaddr_in6);
	sin->sin6_family = AF_INET6;
	COPY_ADDR6(agp->home, sin->sin6_addr);
	ADVANCE(cp, sin);

	rtm.rtm_msglen = len = cp - (char *)&m_rtmsg;

	DUMPR("force_nd");
	if (write(r, (char *)&m_rtmsg, len) < len) {
		if ((type == RTM_ADD) && (errno == EEXIST)) {
			type = RTM_CHANGE;
			goto retry;
		}
		if (verbose)
			logperror("write (force_nd)");
		return;
	} else if (verbose)
		logtrace("force_nd for %s on %s#%d",
			 inet6pr(&rp->rta), rp->ifp->name, rp->ifp->index);
}

struct interface * home_if(agp)
struct corr *agp;
{
	struct homeaddr *hap;
	struct prefix *pp;
	struct interface *ifp;

	/* find the home address */

	FORALLHA(hap)
		if (IN6_ARE_ADDR_EQUAL(&agp->home, &hap->addr))
			break;
	if (hap == NULL) {
		logerr("home_if: no home address");
		return NULL;
	}
	if (hap->state != HAST_IN) {
		logerr("home_if: %s not at home", inet6pr(&hap->addr));
		return NULL;
	}

	/* find the home prefix */

	pp = HAPP(hap);
	if (pp == NULL) {
		logerr("home_if: no home prefix");
		return NULL;
	}
	if ((pp->mflags & MOB_ISHA) == 0)
		logerr("home_if: %s/%d is not a home prefix",
		       inet6pr(&pp->addr), pp->plen);
	if (pp->mflags & MOB_ISFA)
		logerr("home_if: %s/%d is a fake home prefix",
		       inet6pr(&pp->addr), pp->plen);
	if ((pp->alen == 128) && verbose)
		logtrace("home_if: %s/%d is not a real prefix (alen=%d)",
			 inet6pr(&pp->addr), pp->plen, pp->alen);

	/* find the home interface */

	ifp = pp->ifp;

	if (ifp == NULL) {
		logtrace("home_if: %s/%d has no interface",
			 inet6pr(&pp->addr), pp->plen);
		return NULL;
	}
	if (!IS_UP(ifp) && verbose)
		logtrace("home_if: home interface %s is not up",
			 ifp->name);

	/* finished */

	if (verbose)
		logtrace("home interface is %s (prefix %s/%d)",
			 ifp->name, inet6pr(&pp->addr), pp->plen);

	return ifp;
}

#endif
