#if defined (uMIP) || (UHMMA)

#include "ndpd.h"
#include "../ndpd-mobility/mobility.h"

char send_kernel(location,buffer,size,src,dst,disable_home,disable_rth)
char * location;	/* string to print if problems occur */
char * buffer;		/* packet to send */
int    size;		/* size of the packet */
struct in6_addr * src;	/* source */
struct in6_addr * dst;	/* destination */
char   disable_home;	/* disable home address option */	
char   disable_rth;	/* disable routing header */
{
    	struct sockaddr_in6 sin;
	int d, cc;

	/* get a fresh socket */
	if ((d = socket(PF_INET6, SOCK_RAW, IPPROTO_DSTOPTS)) < 0) 
	{
		logtrace("socket %s",location);
		return 0;
	}
	(void) shutdown(d, 0);
	/* bind it */
	bzero((caddr_t)&sin, sizeof(sin));
	sin.sin6_family = AF_INET6;
	sin.sin6_len = sizeof(sin);
	COPY_ADDR6(*src, sin.sin6_addr);
	if (bind(d, (struct sockaddr *)&sin, sizeof(sin)) < 0) 
	{
		logtrace("bind %s",location);
		(void) close(d);
		return 0;
	}
	/* connect it */
	COPY_ADDR6(*dst, sin.sin6_addr);
	if (connect(d, (struct sockaddr *)&sin, sizeof(sin)) < 0) 
	{
		logtrace("connect %s",location);
		(void) close(d);
		return 0;
	}
	if(disable_home==1)
	    disable_homeaddr(d);
	/* send */
	cc = write(d, buffer, size);   
	if (cc != size)
	{
		logtrace("write %s",location);
		(void) close(d);
	    return 0;
	}
	(void) close(d);
	return 1;
}

/* todo : change logtrace by logperror */
#endif
