/*
uhmma.h

share betwenn ndpd-host and ndpd-router
*/
#define TRUE			1
#define FALSE			0
#define OK			1
#define KO			0

#define ND_OPT_MA 		100

#define OPT6_MA_ANNONCE 	200
#define SUB_OPT6_HA 		103
#define SUB_OPT6_VCOA 		107
#define SUB_OPT6_MA 		102
#define SUB_OPT6_CN 		109

#define OPT6_BNDA_MA_REFUSED 	100
#define OPT6_BNDA_CN_LIST_OK	111
#define OPT6_BNDA_CN_LIST_KO	112
#define OPT6_BNDA_MODE		113

#define REEMIT_REG_INTERVAL 	10
#define BACK_TO_HOME_TIMEOUT 	30
#define OLD_POSITION_TIMER 	60
#define SMOOTH_TIMER 		10
#define MA_ANNONCE_TIMER 	240
#define PURSUIT_TIMEOUT		60

#define DEFAULT_MH_LIFETIME 	240
#define DEFAULT_MH_REFRESH 	200

#define OLD_POSITION_FLAG 	1
#define FORWARD_FLAG 		2
#define SMOOTH_FLAG 		4

#define UHMMA_BU_DO_LENGTH 	48
#define UHMMA_MA_SUBO_LENGTH 	18
#define UHMMA_HA_SUBO_LENGTH 	18

#define DEFAULT_SITE_LEN	6	/* in bytes */

#define UHMMA_MODE1 		1
#define UHMMA_MODE2 		2
#define UHMMA_MODE2_FROM_MIP 	20
#define MIP_MODE 		0

#define VCOA_NEEDED 	1
#define NO_VCOA_NEEDED 	0
#define HOME_NEEDED 	2

#define MAX_RETRANS	8

#define DESTROY_TIMER(tm) if(tm) {tm->refcnt=0;kill_timeout(tm);tm=NULL;}
#define RESTART_TIMER(tm,lap,func,param) if (tm){tm->refcnt ++;kill_timeout(tm);set_timeout(tm,lap, 0, (func_to)func,param);}
#define START_TIMER(tm,lap,func,param) if (tm){set_timeout(tm,lap, 0, (func_to)func,param);}
#define ADD_TIMER(tm,lap,func,param) if (!tm){tm=new_timeout(lap, 0, (func_to)func,param);}
#define ADD_SUPER_TIMER(tm,lap,func,param) if (!tm){tm=new_timeout(lap, 0, (func_to)func,param);if(tm){tm->refcnt=1;}}




#define OPT6_ROUTE_UPD          9
#define OPT6_PAGING_UPD         10 

#ifndef KAME_ND6
struct nd_opt_MA_address	/* to be inserted in rt adv */
{
    char nd_opt_MA_type;	/* type of this option */
    char nd_opt_MA_len;		/* length of this option */
    char mode;				/* MA mode  1|2 */
    u_char plen;			/* prefix length of the virtual network */
/*	u_int  parea;	*/		/* number of the paging area number */
    struct in6_addr ma;		/* MA address */
};
#else /* KAME_ND6 */
struct nd_opt_MA_address
{
	u_int8_t		type;	/* type of this option */
	u_int8_t		len;	/* length of this option */
	u_int8_t		dis;	/* distance between the MH and the MA */
	u_int8_t		prf;	/* preference of the MA */
	u_int8_t		plen;	/* prefixe length of the virtual network */
	u_int8_t		flags;	/* flags */
	u_int16_t		reserved;
	u_int32_t		life;	/* lifetime of the MA */
	struct in6_addr	 addr;	 /* the MA ipv6 address */
};
#endif /* KAME_ND6 */

struct corr4list
{
	struct in6_addr addr;		/* correspondent address */
	u_char  flags;			/* flags to use in updates */
	u_char  plen;			/* prefix length */
	u_int   lifetime;		/* life time */
/*	u_int   retcnt;*/			/* retrans counter */
	int   type;			/* type */
	u_short seq;			/* sequence number */
};

char send_kernel(char * ,char * ,int ,struct in6_addr * ,
		    struct in6_addr *,char,char );

/* ************************************************************************* 

#     # #     # #     # #     #    #
#     # #     # ##   ## ##   ##   # #
#     # #     # # # # # # # # #  #   #
#     # ####### #  #  # #  #  # #     #
#     # #     # #     # #     # #######
#     # #     # #     # #     # #     #
 #####  #     # #     # #     # #     #


*************************************************************************** */
#ifdef UHMMA

#define MOB_ISVA           16      /* is a virtual address */


struct var_global
{
  TAILQ_HEAD(, prefix)  Vpref;		/* list of voca prefix */
  char 	MA_mode;			/* MA mode 1|2 */
  char  fast;				/* fast handoff ? */
  char 	mobility_mode;			/* the current mobility mode */
  char 	mobility_mode_init;		/* the user mobility mode choice */
  char  need_to_swap;			/* is set while swapping */
  char  swap_in_progress;		/* mode swap in progress ? */
  char 	switch_in_progress;		/* an ethernet movement in progress ? */
  char * reemit_reg_packet;             /* registration packet */
  int 	seq_num;                        /* sequence number */
  short	nbBACK;         		/* number of waitin BACK */
  struct corr     * 	HA;             /* Home agent */
  struct corr		*	MA;				/* Mobility agent */
  struct in6_addr 	MA_address;     /* local MA */
  struct in6_addr 	MA_old;         /* previous MA */
  struct in6_addr 	MA_readed;      /* MA readed in the rt adv*/
  struct in6_addr 	VCOA;		/* the vcoa itself */
  struct timeout  * 	back_timer;     /* */
  struct timeout  * 	reemis_timer;   /* retransmit timer */
  struct timeout  * 	uMIP_timer;     /* old position timer */
  u_char	MA_plen;		/* prefix length of virtual network */
  u_char	site_len;		/* site prefix length */
  u_char	reg_ret;		/* number of retransmissions */
  u_char	reg_ret_max;		/* max. number of retransmissions */
  u_short	pkt_size;		/* size of the reemission packet */
};

struct temp_global
{
  u_int  forward;		/* forwarding while moving between two domain */
  u_int  home;			/* forwarding when returning to home */
  u_int  lifetime;		/* default lifetime sent to a MA */
  u_int  position;		/* interval for sending old position */
  u_int  refresh;		/* default refresh */
  u_int  retransmission;	/* interval between two registrations */
  u_int  smooth;		/* interval between two smooth handoffs */
};

#define FORALLVP(vp) \
    for(vp = global.Vpref.tqh_first; vp; vp = vp->prf_list.tqe_next)

/* global variables declaration */

extern char		    verboseU;		/* verbose for UHMMA only */
extern struct var_global    global;
extern struct temp_global   temp;
extern int		    socket_bpf;		/* socket for state detection */

/* function */


char same_eui64			(struct in6_addr * ,struct in6_addr *);
char same_prefix		(struct in6_addr * ,struct in6_addr * ,int );
char uhmma_back_check		(struct ip6_hdr *,u_short ,u_char *,int,u_char);
char uhmma_move_mode		(struct in6_addr *);
struct in6_addr make_VCOA	(struct in6_addr *);
void add_VCOA			(struct interface * ,struct in6_addr * );
void build_send_reg		(struct in6_addr * ,int ,char, char );
void clear_back_tug 		();
void deprec_pref		(struct prefix *,int,int);
void dump_uhmma			();
void madd_ma_tunnel		(struct corr *);
void mdel_ma_tunnel		(struct corr *);
void mobile_uhmma_clean		();
void mobile_uhmma_init		();
void recv_bpf2			();
void recv_ma_ann		(char *);
void resend_cn_list		(char *);
void resend_uhmma_reg		(char * );
void send_bnd_upd		(struct corr *);
void send_cn_list		(struct in6_addr *);
void send_forward		(struct in6_addr *);
void send_old_position 		();
void send_smooth		(struct in6_addr *);
void send_uhmma_major_reg	(struct in6_addr *);
void send_uhmma_minor_reg	(struct in6_addr *);
void stop_UHMMA			(struct in6_addr *);
void store_cn_list		(struct ip6_hdr *,u_char *,int);
void uhmma_move			(struct in6_addr *);
void update_cn_list		();




#endif
/***********************************************************************


        #     #   ###   ######
 #    # ##   ##    #    #     #
 #    # # # # #    #    #     #
 #    # #  #  #    #    ######
 #    # #     #    #    #
 #    # #     #    #    #
  ####  #     #   ###   #



************************************************************************/
#ifdef uMIP

#define FORALLMAMH(mh) \
    for(mh = listMH.tqh_first; mh; mh = mh->mb_list.tqe_next)

#define FORALLMHCORR(mh, ch) \
    for(ch = mh->CH.tqh_first; ch ; ch = ch->cr_list.tqe_next)

#define FORALLWB(wb) \
    for(wb = waitingBack.tqh_first; wb; wb = wb->wb_list.tqe_next)

#define FORALLBS(bs) \
    for(bs = listBS.tqh_first; bs; bs = bs->bs_list.tqe_next)

#define FORALLMA(ma)\
    for(ma = listMA.tqh_first; ma; ma = ma->ma_next.tqe_next)


#define ME interfaces.tqh_first->prefixes.tqh_first->addr

#define MOBILE_MAX 	10
#define ND_OPT_CH	117
#define DEFAULT_MA_LIFETIME	30

/* structures definition */
struct WBACK
{
    char             * 	pkt;		/* registration packet */
    int	   		pkt_size;	/* registration packet size */
    struct in6_addr 	MA;		/* MA slave */
    struct mobile    * 	MH;		/* the mobile host */
    struct timeout   * 	tm;		/* timer for retransmission */
    TAILQ_ENTRY(WBACK) 	wb_list;	/* next one */
    u_short		retrans;	/* number of retransmissions */
};

struct temp_global
{
  u_int  annonce;		/* interval between two ma annonce */
  u_int  forward;		/* forwarding while moving between two domain */
  u_int  home;			/* forwarding when returning to home */
  u_int  lifetime;		/* default lifetime sent to a MA */
  u_int  refresh;		/* default refresh */
  u_int  smooth;		/* interval between two smooth handoffs */
};

struct BaseStation
{
    struct in6_addr		addr;		/* the address of the BS */
    TAILQ_ENTRY(BaseStation) 	bs_list;	/* next one */
};

struct MobilityAgent
{
    struct in6_addr		addr;	/* the address of the MA */
    struct timeout	*	life;	/* the lifetime timer */
    u_short 			charge;	/* the charge of the MA */
    TAILQ_ENTRY(MobilityAgent)	ma_next;/* next one */
};

struct Vprefix
{
    char 		name[4];	/* the virtual interface name */
    char		root[4];	/* the root interface name */
    int 		plen;		/* the prefix length */
    struct in6_addr 	pref;		/* the prefix itsef */
    struct interface * 	itf;		/* the interface on the virtual prefix */
    struct prefix    * 	pp;		/* a pointer to the virtual prefix structure */
};

struct nd_opt_MA_charge
{
    char nd_opt_MA_type;	/* type of this option */
    char nd_opt_MA_len;		/* length of this option */
    u_short charge;		/* the charge */
    struct in6_addr nd_opt_MA_address;	/* MA address */
};

struct corr 
{
	TAILQ_ENTRY(corr) cr_list;	/* correspondent list */
	struct in6_addr   addr;		/* correspondent address */
	struct in6_addr   careof;	/* care-of address */
	struct in6_addr   home;		/* home address */
	struct timeout *  tp;		/* timeout */
	int type;			/* type */
#define CORR_HAONLY	0
#define CORR_FULL	1
	u_char  flags;			/* flags to use in updates */
	u_char  plen;			/* prefix length */
	u_short seq;			/* sequence number */
	u_int   lifetime;		/* life time */
	u_int   retcnt;			/* retrans counter */
	struct timeout *rettp;		/* retrans timeout */
	caddr_t sap;			/* pointer to SA (TODO) */
#if defined (UHMMA) || (uMIP)
	struct in6_addr VCOA;
#endif  
};

/* global variables */
extern char 		  MA_op;		/* mode 1 or 2 */
extern char		  max_retrans;		/* number max of smooth retransmissions */
extern char		  verboseU;		/* verbose for UHMMA only */
extern int		  socket_bpf;		/* socket for CN detection */
extern u_char		  site_len;		/* length of the site prefix */
extern u_short		  charge;		/* the charge */
extern struct in6_addr	  MA_address;		/* address on the virtual prefix */
extern struct temp_global temp;			/* list of timer's vallues */
extern struct timeout *   MA_annonce_timer;	/* timer for sending ma annonce */
extern struct Vprefix 	  VirtualNetwork;	/* virtual network data */
TAILQ_HEAD(, BaseStation) listBS;		/* MA data are sent to this addresses */
TAILQ_HEAD(, MobilityAgent)listMA;		/* list of MA on the virtual link */
TAILQ_HEAD( ,mobile) 	  listMH;		/* list of managed mobile hosts */
TAILQ_HEAD(, WBACK) 	  waitingBack;		/* list for smooth handoff */


/* functions */
char mobile_forward	(struct mobile *,int ,int ,struct in6_addr *,struct in6_addr *);
char open_bpf		();
char uhmma_back_check   (struct ip6_hdr *i,u_short);
char  same_prefix	(struct in6_addr * ,struct in6_addr * ,int );
struct corr * add_corr	(struct in6_addr * ,struct mobile * );
void close_bpf		();
void dump_MA		();
void kill_mobile	(struct mobile *);
void ma_uhmma_clean	();
void ma_uhmma_init	();
void recv_bpf		();
void recv_cn_list	(struct in6_addr *,u_char *,int);
void recv_forward	(struct ip6_hdr *,u_char *,struct in6_addr *);
void recv_ma_ann	(u_char * );
void recv_smooth	(struct ip6_hdr *,u_char *,struct in6_addr *);
void recv_uhmma_reg 	(struct ip6_hdr *, u_char ** ,struct in6_addr *);
void send_bnd_upd	(struct corr *);
void send_cn_list	(struct mobile *,struct in6_addr *);
void send_forward	(struct in6_addr * ,struct mobile * );
void send_home_red	(struct corr *);
void send_MA_annonce	(char);
void send_smooth	(struct in6_addr *,struct mobile * );
void send_uhmma_back	(struct ip6_hdr *,int,struct mobile * ,struct in6_addr * );
void update_MA		(struct in6_addr * ,u_short );


#endif
/***********************************************************************


        #     #   ###   ######  ######   #####
 #    # ##   ##    #    #     # #     # #     #
 #    # # # # #    #    #     # #     # #
 #    # #  #  #    #    ######  ######   #####
 #    # #     #    #    #       #     #       #
 #    # #     #    #    #       #     # #     #
  ####  #     #   ###   #       ######   #####


************************************************************************/
#ifdef uMIPBS
struct MA_data
{
    struct in6_addr MA_address;
    char mode;
    u_char plen;
};

extern char 	BS_op;				/* is this host a BS ? */
extern char		verboseU;			/* verbose for UHMMA only */
extern u_char	site_len;			/* length of the site prefix */
/*extern char		parea;				*//* the paging area number */
extern struct MA_data   MA_info;	/* local MA */

void bs_uhmma_clean	();
void bs_uhmma_init	();
void dump_BS		();
void recv_MA_data	(u_char *);

#endif
